/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kalkulackaenum;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova at tul.cz>
 */
public enum FunkceKalkulacky {

    SCITANI("Sčítání", "+", "první sčítanec", "druhý sčítanec") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
            operand2 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu2 + ": ");
        }

        @Override
        public double vypocet() {
            return operand1 + operand2;
        }

        @Override
        public void vystup(double vysledek) {
            String text = operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek;
            System.out.println(operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    ODCITANI("Odčítání", "-", "menšenec", "menšitel") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
            operand2 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu2 + ": ");
        }

        @Override
        public double vypocet() {
            return operand1 - operand2;
        }

        @Override
        public void vystup(double vysledek) {
            String text = operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    NASOBENI("Násobení", "*", "první činitel", "druhý činitel") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
            operand2 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu2 + ": ");
        }

        @Override
        public double vypocet() {
            return operand1 * operand2;
        }

        @Override
        public void vystup(double vysledek) {
            String text = operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    DELENI("Dělení", "/", "dělenec", "dělitel") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
            operand2 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu2 + ": ");
        }

        @Override
        public double vypocet() {
            return operand1 / operand2;
        }

        @Override
        public void vystup(double vysledek) {
            String text = operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    MOCNINA("Umocňování", "^", "základ mocniny (mocněnec)", "exponent (mocnitel)") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
            operand2 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu2 + ": ");
        }

        @Override
        public double vypocet() {
            return Math.pow(operand1, operand2);
        }

        @Override
        public void vystup(double vysledek) {
            String text = operand1 + " " + getOperator() + " " + operand2 + " = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    SINUS("Sinus", "sin", "číslo v radiánech", "") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
        }

        @Override
        public double vypocet() {
            return Math.sin(operand1);
        }

        @Override
        public void vystup(double vysledek) {
            String text = getOperator() + "(" + operand1 + ") = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    },
    COSINUS("Kosinus", "cos", "číslo v radiánech", "") {
        @Override
        public void vstup() {
            operand1 = VstupyVystupy.zadejRealneCislo("Zadej " + nazevOperandu1 + ": ");
        }

        @Override
        public double vypocet() {
            return Math.cos(operand1);
        }

        @Override
        public void vystup(double vysledek) {
            String text = getOperator() + "(" + operand1 + ") = " + vysledek;
            System.out.println(text);
            KalkulackaEnum.getSoubor().println(text);
        }
    };

    public abstract void vstup();

    public abstract double vypocet();

    public abstract void vystup(double vysledek);

    private final String nazevFunkce;
    private final String operator;
    final String nazevOperandu1;
    final String nazevOperandu2;
    double operand1;
    double operand2;
    private double vysledek;

    FunkceKalkulacky(String nazevFunkce, String operator, String nazevOperandu1, String nazevOperandu2) {
        this.nazevFunkce = nazevFunkce;
        this.operator = operator;
        this.nazevOperandu1 = nazevOperandu1;
        this.nazevOperandu2 = nazevOperandu2;
    }

    public String getNazevFunkce() {
        return nazevFunkce;
    }

    public String getOperator() {
        return operator;
    }

    public double getVysledek() {
        return vysledek;
    }
}
